import { Component, ChangeDetectionStrategy, Inject, PLATFORM_ID, ElementRef, HostBinding, Input, NgModule } from '@angular/core';
import { isPlatformBrowser, CommonModule } from '@angular/common';
import { HighlightJsService, HighlightJsModule } from 'angular2-highlight-js';
import { __values } from 'tslib';
import * as _marked from 'marked';

/**
 * @fileoverview added by tsickle
 * Generated from: lib/components/code-snippet/code-snippet.component.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @type {?} */
var marked = _marked;
var CodeSnippetComponent = /** @class */ (function () {
    function CodeSnippetComponent(platformId, el, highlightJsService) {
        this.platformId = platformId;
        this.el = el;
        this.highlightJsService = highlightJsService;
        this.setClass = true;
        this.processMarkdown = false;
        this.scrollable = true;
    }
    /**
     * @return {?}
     */
    CodeSnippetComponent.prototype.ngOnChanges = /**
     * @return {?}
     */
    function () {
        if (this.processMarkdown) {
            this.codeSnippet = marked(this.codeSnippet);
        }
    };
    /**
     * @return {?}
     */
    CodeSnippetComponent.prototype.ngAfterViewInit = /**
     * @return {?}
     */
    function () {
        var e_1, _a;
        if (isPlatformBrowser(this.platformId)) {
            /** @type {?} */
            var allPreEl = this.el.nativeElement.querySelectorAll('pre');
            try {
                for (var allPreEl_1 = __values(allPreEl), allPreEl_1_1 = allPreEl_1.next(); !allPreEl_1_1.done; allPreEl_1_1 = allPreEl_1.next()) {
                    var preElement = allPreEl_1_1.value;
                    if (!preElement.classList.contains('a-pre')) {
                        preElement.className += ' a-pre';
                        if (this.scrollable) {
                            preElement.className += ' a-pre--scrollable';
                        }
                    }
                    this.highlightJsService.highlight(preElement);
                }
            }
            catch (e_1_1) { e_1 = { error: e_1_1 }; }
            finally {
                try {
                    if (allPreEl_1_1 && !allPreEl_1_1.done && (_a = allPreEl_1.return)) _a.call(allPreEl_1);
                }
                finally { if (e_1) throw e_1.error; }
            }
        }
    };
    CodeSnippetComponent.decorators = [
        { type: Component, args: [{
                    selector: 'aui-code-snippet',
                    template: "<div class=\"aui-code-snippet__inner\">\n  <pre *ngIf=\"!this.processMarkdown\"><code>{{ codeSnippet }}</code></pre>\n\n  <div *ngIf=\"this.processMarkdown\" [innerHTML]=\"codeSnippet\" class=\"code-snippet-md\"></div>\n</div>\n",
                    changeDetection: ChangeDetectionStrategy.OnPush
                }] }
    ];
    /** @nocollapse */
    CodeSnippetComponent.ctorParameters = function () { return [
        { type: undefined, decorators: [{ type: Inject, args: [PLATFORM_ID,] }] },
        { type: ElementRef },
        { type: HighlightJsService }
    ]; };
    CodeSnippetComponent.propDecorators = {
        setClass: [{ type: HostBinding, args: ['class.ngx-code-snippet',] }],
        codeSnippet: [{ type: Input }],
        processMarkdown: [{ type: Input }],
        scrollable: [{ type: Input }]
    };
    return CodeSnippetComponent;
}());
if (false) {
    /** @type {?} */
    CodeSnippetComponent.prototype.setClass;
    /** @type {?} */
    CodeSnippetComponent.prototype.codeSnippet;
    /** @type {?} */
    CodeSnippetComponent.prototype.processMarkdown;
    /** @type {?} */
    CodeSnippetComponent.prototype.scrollable;
    /**
     * @type {?}
     * @private
     */
    CodeSnippetComponent.prototype.platformId;
    /**
     * @type {?}
     * @private
     */
    CodeSnippetComponent.prototype.el;
    /**
     * @type {?}
     * @private
     */
    CodeSnippetComponent.prototype.highlightJsService;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/code-snippet.module.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var CodeSnippetModule = /** @class */ (function () {
    function CodeSnippetModule() {
    }
    CodeSnippetModule.decorators = [
        { type: NgModule, args: [{
                    imports: [
                        CommonModule,
                        HighlightJsModule,
                    ],
                    declarations: [
                        CodeSnippetComponent,
                    ],
                    providers: [
                        HighlightJsService,
                    ],
                    exports: [
                        CodeSnippetComponent,
                    ],
                },] }
    ];
    return CodeSnippetModule;
}());

/**
 * @fileoverview added by tsickle
 * Generated from: public-api.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * Generated from: acpaas-ui-ngx-code-snippet.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { CodeSnippetComponent, CodeSnippetModule };
//# sourceMappingURL=acpaas-ui-ngx-code-snippet.js.map
